/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *
 *  TOPPERS/JSP for Blackfin
 *
 *  Copyright (C) 2004,2006,2006 by Takemasa Nakamura
 *  Copyright (C) 2004 by Ujinosuke
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 *
 */

/*
 *	^C}hCoiADSP-BF533pj
 *
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

#include <s_services.h>
#include <sil.h>

#ifndef _MACRO_ONLY




/**************************************************************
 *  ^C}̋N
 *
 *  ^C}CIȃ^C}ݗv𔭐D
 *
 **************************************************************/
Inline void
hw_timer_initialize()
{
#ifdef USE_TIC_CORE
	// Core timer
	// TCNTL bit assignement
	// TMPWR                  0x00000001
	// TMREN                  0x00000002
	// TAUTORLD               0x00000004
	// TINT                   0x00000008
	*__pTCNTL = 0x00000001;					// TMPWR : power up timer;
	*__pTPERIOD = CORECLOCK/1000;			// CORE CLOCK is defined in sys_config.h
	*__pTCNTL = 0x00000007;					// TMPWR | TMREN | TAUTORLD;
#else
	// GPT2(General-purpose timer2)


	/* TIMERx_CONFIG Registers */
	// PWM_OUT		0x0001
	// WDTH_CAP		0x0002
	// EXT_CLK		0x0003
	// PULSE_HI		0x0004
	// PERIOD_CNT	0x0008
	// IRQ_ENA		0x0010
	// TIN_SEL		0x0020
	// OUT_DIS		0x0040
	// CLK_SEL		0x0080
	// TOGGLE_HI	0x0100
	// EMU_RUN		0x0200

	*__pTIMER2_CONFIG = 0x0059; // PERIOD_CNT | OUT_DIS |IRQ_ENA | PWM_OUT ( PWM_OUT, Output Pad disable)
	*__pTIMER2_PERIOD = SYSCLOCK/1000;	// SYS CLOCK is defined in sys_config.h
	*__pTIMER2_WIDTH = 1;					// 0 < width < period

	// TIMEN0			0x0001
	// TIMEN1			0x0002
	// TIMEN2			0x0004
	*__pTIMER_ENABLE = 0x004;			// TIMEN2 timer2 start

	ena_int( INHNO_TIMER );				// enable Timer Interrupt
#endif
	asm("ssync;");

}

/**************************************************************
 *  ^C}ݗṽNA
 **************************************************************/
Inline void
hw_timer_int_clear()
{
#ifdef USE_TIC_CORE
	// Core timer
	// TCNTL bit assignement
	// TMPWR                  0x00000001
	// TMREN                  0x00000002
	// TAUTORLD               0x00000004
	// TINT                   0x00000008
	*__pTCNTL = 0x0000000F;	// TMPWR | TMREN | TAUTORLD | TINT;
#else
	// GPT2(General-purpose timer2)

	// TIMIL0			0x0001
	// TIMIL1			0x0002
	// TIMIL2			0x0004
	*__pTIMER_STATUS = 0x004;	// TIMIL2, Clear interrupt
#endif
	asm("ssync;");
}

/**************************************************************
 *  ^C}̒~
 *
 *  ^C}̓~D
 **************************************************************/
Inline void
hw_timer_terminate()
{
	/*
	 *  ^C}̓~D
	 */
#ifdef USE_TIC_CORE
	// Core timer
	// TCNTL bit assignement
	// TMPWR                  0x00000001
	// TMREN                  0x00000002
	// TAUTORLD               0x00000004
	// TINT                   0x00000008
	*__pTCNTL = 0x0000000D;	//TMPWR | TAUTORLD | TINT;		// ~
	*__pTCNTL = 0;							// p[_E[h
#else
	// GPT2(General-purpose timer2)
	// TIMDIS0			0x0001
	// TIMDIS1			0x0002
	// TIMDIS2			0x0004
	*__pTIMER_DISABLE = 0x004;			// TIMDIS2, timer2 disable
#endif
	asm("ssync;");
}


#endif /* _MACRO_ONLY */
#endif /* _HW_TIMER_H_ */
